import React from 'react';
import CheckinSelfStore from "../../../stores/CheckinSelfStore";
import Register from "./Register";
import Greeting from "./Greeting";
import SpontanGuidance from "./SpontanGuidance";

class CheckinSelf extends React.Component {

  constructor(props){
    super(props)
    this.state ={
      display: CheckinSelfStore.getCheckinSelf(),
      registered: false
    }

    this.update = this.update.bind(this);
    this.checkResults = this.checkResults.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.registered = this.registered.bind(this);
  }

  handleChange(event) {}

  componentDidMount (){
    CheckinSelfStore.on("checkinSelfStore_loaded", this.update);
    CheckinSelfStore.on("QRCoded_scanned", this.checkResults);
    CheckinSelfStore.on("visitor_registered", this.registered);
  }

  checkResults(){
    this.setState({
      display : CheckinSelfStore.getCheckinSelf()
    })
  }

  update(){
    this.setState({
      display : CheckinSelfStore.getCheckinSelf(),
    })
  }

  registered(){

    var checkin = CheckinSelfStore.getCheckin();
    console.log(checkin);
    this.setState({
      checkin: checkin,
      registered : true,
    })
  }

  render() {
    let content = null;
    console.log( this.state.checkin );
    if( this.state.checkin ){
      console.log( this.state.checkin.length );
      content = <SpontanGuidance checkin={this.state.checkin} />;
    }else if(this.state.registered){
      content = <Greeting />;
    }else{
      content = <Register />;
    }

    return (
      <div id="CheckinSelf" className="page">
        {content}
      </div>
    );
  }
}

export default CheckinSelf;
