import React from 'react';
import Iframe from 'react-iframe'
import {properties } from '../../../properties.js';
import CheckinStore from "./../../../stores/CheckinStore";
import DesignStore from "./../../../stores/DesignStore";
import Greeting from "./Greeting";
import LanguageStore from "./../../../stores/LanguageStore";

class SpontanGuidance extends React.Component {

  constructor(props){
    super(props)
    this.state ={
      checkin : props.checkin,
      selection: null,
      timer : null,
      designs : DesignStore.getDesign()
    }

    this.update = this.update.bind(this);
    this.listGui = this.listGui.bind(this);
    this.startWatcher = this.startWatcher.bind(this);
    this.click_listener=null;
  }

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  startWatcher () {

      clearTimeout(window.globals["resetTimer"]);

      this.timer = setInterval(function(){
      var iframe = document.getElementById('guidanceFrame');

      if(iframe){
        var innerDoc = iframe.contentDocument || iframe.contentWindow.document;
        if( this.click_listener == null ){
          this.click_listener = window.$(innerDoc).find("body").click(window.globals["resetTimer_reset"]);
        }

        innerDoc.addEventListener('touchstart', function(event){
          if(event.touches.length > 1){
            event.preventDefault();
          }

        }, {passive: false});

      }else{
        clearInterval(this.timer);
      }

       if(window.$(innerDoc).find("#guidance_success").length !== 0){
         clearInterval(this.timer);
         this.resetSelection();
       }
     }.bind(this), 500)
  }

  resetSelection(){

    var guidance = this.state.checkin.guidance.filter(function(value, index, arr){
      return value.gui_id !== this.state.selection.gui_id;
    }.bind(this) );

    var checkin = this.state.checkin;
    checkin.guidance = guidance;

    if(checkin.guidance.length == 0){
      this.setState({
        done:true,
        selection:null
      });
    }else{
      this.setState({
        checkin:checkin,
        selection:null
      });
    }

  }

  singleGui(){

    let baseURL = properties.guidance;
    let tokenPart ="?SID=" + properties.key;
    let params ="&gui_id=9&action=start_guide&jau_id=" +
    this.state.checkin.aps.aps_jau_id + "&gui_id=" + this.state.selection.gui_id
    let iframeURL = baseURL + tokenPart + params;
    this.startWatcher();

    // <h1>{LanguageStore.translate("checkin_guidance")}</h1>
    return (
      <div id="guidance">
        <Iframe url={iframeURL}
        width="450px"
        height="450px"
        id="guidanceFrame"
        className="myClassname"
        display="initial"
        position="relative"/>
      </div>
    );

  }

  guiSelected(e, item){
    this.state.checkin.guidance = this.state.checkin.guidance.filter(function(value, index, arr){
      return value.gui_id !== item.gui_id;
    });
    this.setState({
      selection : item
    });
  }

  listGui(){
    let buttonStyles = null

    if(this.state.designs){
      buttonStyles = {
        backgroundColor:this.state.designs["main_color"]
      };
    }

    return (
      <div className="guidance_list">
      <h1>{LanguageStore.translate("checkin_guidance_missing")}</h1>
        <ul>
          {this.state.checkin.guidance.map(function(gui, index){
            return <li className="button btn-guid" style={buttonStyles} onClick={(e) => this.guiSelected(e, gui)} key={ index }>{gui.gui_name}</li>;
          }.bind(this))}
        </ul>
      </div>
    )
  }

  render() {

    let content = (<div></div>);

    if( this.state.done ){
      content = <Greeting />;
    }else if(this.state.selection !== null){
      content = this.singleGui();
    }else{
      content = this.listGui();
    }



    return(
      content
    )
  }
}

export default SpontanGuidance;
